/*
 * Copyright (c) 2015-2017, The Linux Foundation. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * * Redistributions of source code must retain the above copyright
 *  notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 * copyright notice, this list of conditions and the following
 * disclaimer in the documentation and/or other materials provided
 *  with the distribution.
 *   * Neither the name of The Linux Foundation nor the names of its
 * contributors may be used to endorse or promote products derived
 * from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef _USBFN_DESCAPP_H_
#define _USBFN_DESCAPP_H_

#include <Uefi.h>
#include <Library/BaseMemoryLib.h>
#include <Library/DebugLib.h>
#include <Library/UefiBootServicesTableLib.h>
#include <Library/UefiLib.h>
#include <Protocol/EFIUsbDevice.h>

/* USB endpoint number for bulk data transfers (both IN/OUT used) */
#define USBLB_BULK_EP 1

/* Converts endpoint index and direction to address. */
#define ENDPOINT_ADDR(EndpointIndex, Tx)                                       \
  ((EndpointIndex) | ((Tx) ? 0x80 : 0x00))

/* Fastboot device/config/interface/endpoint descriptor set */
extern EFI_USB_DEVICE_QUALIFIER_DESCRIPTOR DeviceQualifier;

/* Fastboot String descriptors */
extern EFI_USB_STRING_DESCRIPTOR *StrDescriptors[5];

VOID
BuildDefaultDescriptors (OUT USB_DEVICE_DESCRIPTOR **DevDesc,
                         OUT VOID **Descriptors,
                         OUT USB_DEVICE_DESCRIPTOR **SSDevDesc,
                         OUT VOID **SSDescriptors);
#endif /* _USBFN_DESCAPP_H_ */
